import sensor,image,lcd,time
import KPU as kpu
import utime
from Maix import GPIO
from fpioa_manager import fm


#LED sur broche 2 -> IO21 de la K210
fm.register(21, fm.fpioa.GPIO0)
led=GPIO(GPIO.GPIO0,GPIO.OUT)





lcd.init(freq=15000000)
sensor.reset()
sensor.set_pixformat(sensor.RGB565)
sensor.set_framesize(sensor.QVGA)
sensor.set_vflip(0)
sensor.run(1)
clock = time.clock()

'''
KPU est un processeur de réseau neuronal. Il peut effectuer
un calcul de réseau neuronal convolutif --> Obtenir la taille, les
coordonnées et les types d'objets détectés.

https://maixpy.sipeed.com/en/libs/Maix/kpu.html

'''


classes = ['Avion', 'velo', 'oiseau', 'bateau', 'bottle', 'bus', 'voiture', 'chat', 'chaise', 'vache', 'diningtable', 'chien', 'cheval', 'moto', 'humain', 'pottedplant', 'brebis', 'sofa', 'train', 'tvmonitor']
task = kpu.load(0x500000) #offset du modèle en flash (qui peut donc en stocker plusieurs)
#le modèle peut être aussi sur carte SD, donner alors le chemin.

anchor = (1.889, 2.5245, 2.9465, 3.94056, 3.99987, 5.3658, 5.155437, 6.92275, 6.718375, 9.01025)
a = kpu.init_yolo2(task, 0.5, 0.3, 5, anchor)

'''
0.5 seuil de proba
0.3 seuil de box_iou ???
5 : nombre d'ancrages
anchor : parametres d'ancrage ???
'''



while(True):
    led.value(0)
    clock.tick()
    img = sensor.snapshot()
    code = kpu.run_yolo2(task, img)  #requete IA sur l'image
    '''
    Si détection -> liste
    Index: the number of layers of the current layer in the network
    Wi: input width
    Hi: input height
    Wo: output width
    Ho: output height
    Chi: number of input channels
    Cho: number of output channels
    Dw: whether it is a depth wise layer
    Kernel_type: convolution kernel type, 0 is 1x1, 1 is 3x3
    Pool_type: pooling type, 0 is not pooled; 1:2x2 max pooling; 2:...
    Para_size: the number of bytes of the convolution parameter of the current layer
    '''
    if code:
        print(code)#affichage terminal
        for i in code:
            print(classes[i.classid()])
            if i.classid()==7: #Si un chat est vu
                led.value(1)
            a=img.draw_rectangle(i.rect(),(255,0,0),5)
            #methodes /image : https://maixpy.sipeed.com/en/libs/machine_vision/image.html
            a = img.draw_string(10,10,classes[i.classid()],(255,0,0), scale=4,x_spacing=0)
            a = lcd.display(img)
    else:
        a = lcd.display(img)

a = kpu.deinit(task)
